/*
  Mot1  Motor Control 1 Gear Drive with Cab
  Low Frequency
 */
int m2h = 3;  //R Left Track
int m2l = 4;  //B Left Track
int m0h = 5;   //R Right Track
int m0l = 6;   //B Right Track
int en  = 2;   //Enable

int fwdon = 1100;      //effectively sets forward speed
int fwdtime = 3000;
int bwdon;
int bwdtime = 5000;
int bwdshift = 38;
int right180time = 1570;
int righton = 1100; //below 900 may be problematic
int left180time = 1560;
int lefton = 1100;
int cyclewidth = 2000;
int speedup = 200;   //Left track time differntial
int deltime = 4000;
unsigned int totalturns = 5500;

int rightsensepin = 7; 
int leftsensepin = 12; 
int  rightsense = LOW;
int  leftsense = LOW;
int ledpin = 13;

int lctr = 0;
unsigned int turns = 0;

// the setup routine runs once when you press reset:
void setup() {                
  // initialize the digital pins as outputs
  pinMode(m2h, OUTPUT);
  pinMode(m2l, OUTPUT);
  pinMode(m0h, OUTPUT);
  pinMode(m0l, OUTPUT);
  pinMode(en,  OUTPUT);
  digitalWrite(m2l, LOW);
  digitalWrite(m2h, LOW);
  digitalWrite(m0l, LOW);
  digitalWrite(m0h, LOW);
  digitalWrite(en,  LOW);
  bwdon = fwdon-bwdshift;
  turns = 0;
  
  pinMode(rightsensepin, INPUT);
  pinMode(leftsensepin, INPUT);
  pinMode(ledpin, OUTPUT);
  digitalWrite (rightsensepin, HIGH);
  digitalWrite (leftsensepin, HIGH);
  //Serial.begin(9600);  
  
}

void loop() 
{
  
  delay(4000);
  //turns = 0;
  while (turns < totalturns)
  {
     //forward
     gofwd(1,fwdon);
     //delay(2);
     rightsense = digitalRead(rightsensepin);
     rightsense = ! rightsense;
     leftsense = digitalRead(leftsensepin);
     leftsense = ! leftsense;
     digitalWrite (ledpin, (leftsense||rightsense));  
     //right
      if (rightsense==1)
        goright(12,lefton+400);
      while (rightsense==1)
    {
      goright(2,righton);    //turn right
      rightsense = digitalRead(rightsensepin);
      rightsense = ! rightsense;
      
    }
    //left
      if (leftsense==1)
        goleft(12,lefton+400);
      while (leftsense==1)
    {
      goleft(2,lefton);   //turn left
      leftsense = digitalRead(leftsensepin);
      leftsense = ! leftsense;
     }
      //delay(10);
      
      
    turns++;
  }  
  delay(random(400,4000));
  turns =0;
  gofwd(4,fwdon+300);
  /*
  goright(right180time,righton);
  delay (deltime);
  while (turns < totalturns)
  {
     rightsense = digitalRead(rightsensepin);
     rightsense = ! rightsense;
     leftsense = digitalRead(leftsensepin);
     leftsense = ! leftsense;
     digitalWrite (ledpin, (leftsense||rightsense));  
     //right
      
      while (rightsense==1)
    {
      goright(2,righton);    //turn right
      rightsense = digitalRead(rightsensepin);
      rightsense = ! rightsense;
      
    }
    //left
      
      while (leftsense==1)
    {
      goleft(2,lefton);   //turn left
      leftsense = digitalRead(leftsensepin);
      leftsense = ! leftsense;
     }
      //delay(10);
      //forward
      gofwd(1,fwdon);
      
    turns++;
  }  
 goleft(left180time,lefton);
 delay (deltime);  
  */
}
void gofwd(int fcnt,int fcycle) {
     int icnt;
     int totcycle;
     icnt = 0;
     totcycle = fcycle+speedup;
     digitalWrite(en, HIGH);
     while (icnt < fcnt)
    {
      digitalWrite(m2h, HIGH);
      digitalWrite(m0h, HIGH);
      delayMicroseconds(fcycle);
      digitalWrite(m0h, LOW);
      delayMicroseconds (speedup);  //Chassis 5 right track is faster
      digitalWrite(m2h, LOW);
      delayMicroseconds(cyclewidth - totcycle);
      icnt++;
    }
    digitalWrite(en, LOW);
  }
void gobwd(int bcnt,int bcycle) {
     int icnt;
     icnt=0;
     digitalWrite(en, HIGH);
     while (icnt < bcnt)
    {
      digitalWrite(m2l, HIGH);
      digitalWrite(m0l, HIGH);
      delayMicroseconds(bcycle); 
      digitalWrite(m2l, LOW);
      digitalWrite(m0l, LOW);
      delayMicroseconds(cyclewidth - bcycle);
      icnt++;
    }
    digitalWrite(en, LOW);
  }
void goright(int rcnt,int rcycle) {
     int icnt;
     icnt=0;
     digitalWrite(en, HIGH);
     while (icnt < rcnt)
    {
      digitalWrite(m2h, HIGH);
      digitalWrite(m0l, HIGH);
      delayMicroseconds(rcycle); 
      digitalWrite(m2h, LOW);
      digitalWrite(m0l, LOW);
      delayMicroseconds(cyclewidth - rcycle);
      icnt++;
    }
    digitalWrite(en, LOW);
  }
void goleft(int lcnt,int lcycle) {
     int icnt;
     icnt=0;
     digitalWrite(en, HIGH);
     while (icnt < lcnt)
    {
      digitalWrite(m2l, HIGH);
      digitalWrite(m0h, HIGH);
      delayMicroseconds(lcycle); 
      digitalWrite(m2l, LOW);
      digitalWrite(m0h, LOW);
      delayMicroseconds(cyclewidth - lcycle);
      icnt++;
    }
    digitalWrite(en, LOW);
  }
